{% extends "front/base_logged.html" %}
{% load i18n %}
{% load render_table from django_tables2 %}

{% block content %}

    {% include "wizard/header.html" %}

    {% if not boundaries %}

    <div class="panel panel-default">
      <div class="panel-heading">
          <strong>{% trans "Carregar Malha" %}</strong>
          <div class="help">
              <button id="help_btn" type="button" class="btn btn-primary btn-xs" data-toggle="tooltip" data-placement="top" title="{% trans 'Mais info' %}" data-title="{% trans 'Mais info' %}" data-title_alt="{% trans 'Menos info' %}">
                  <span class="glyphicon glyphicon-question-sign"></span>
              </button>
              <button id="tips_btn" type="button" class="btn btn-primary btn-xs" data-toggle="tooltip" data-placement="top" title="{% trans 'Dicas' %}">
                  <span class="glyphicon glyphicon-info-sign"></span>
              </button>
          </div>
      </div>
      <div id="help" class="alert alert-warning cst_hide">
          {% include "wizard/help_text/step_domain.html" %}
      </div>
      <div class="panel-body">
        {% blocktrans trimmed %}
          Neste passo terá de fornecer a malha de cálculo na qual será feita a previsão, de acordo
          com o formato estabelecido no modelo escolhido no passo anterior. Esta malha representará o domínio geográfico
          em estudo. Deverá também indicar os sistemas de coordenadas horizontal e vertical em que a mesma se encontra.
        {% endblocktrans %}
        {% if baroclinic_type and "3d" in baroclinic_type %}
          <br/>
        {% blocktrans trimmed %}
          Para corridas do tipo 3D terá, adicionalmente à malha horizontal, é necessário também fornecer uma malha
          vertical.
        {% endblocktrans %}
        {% endif %}
        <!--
            TODO: remove this QuickFix when BD translations solution is implemented
            {% trans "EPSG:27493 | Datum 73 / Hayford-Gauss" %}
            {% trans "EPSG:20790 | Datum Lisboa / Hayford-Gauss com falsa origem - Coordenadas Militares" %}
            {% trans "EPSG:5018 | Datum Lisboa / Hayford-Gauss" %}
            {% trans "EPSG:5016 | ITRF93 / PTRA08 - UTM zona 28N) – Madeira, Porto Santo, Desertas e Selvagens" %}
            {% trans "EPSG:5015 | ITRF93 / PTRA08 - UTM zona 26N) - Grupo Central e Oriental do Arquipélago dos Açores" %}
            {% trans "EPSG:5014 | ITRF93 / PTRA08 - UTM zona 25N) - Grupo Ocidental do Arquipélago dos Açores" %}
            {% trans "EPSG:5013 | ITRF93 / Coordenadas Geocêntricas 2D" %}
            {% trans "EPSG:5012 | ITRF93 / Coordenadas Geocêntricas 3D" %}
            {% trans "EPSG:5011 | ITRF93 / Coordenadas Geocêntricas" %}
            {% trans "EPSG:4937 | ETRS89 / Coordenadas Geográficas 3D" %}
            {% trans "EPSG:4326 | WGS84 / Coordenadas Geográficas" %}
            {% trans "EPSG:4274 | Datum 73 / Coordenadas Geográficas 2D" %}
            {% trans "EPSG:4258 | ETRS89 / Coordenadas Geográficas 2D" %}
            {% trans "EPSG:4207 | Datum Lisboa / Coordenadas Geográficas 2D" %}
            {% trans "EPSG:3763 | ETRS89 / PT-TM06" %}
            {% trans "EPSG:2942 | Datum Base SE - Porto Santo (Madeira) / UTM zona 28N" %}
            {% trans "EPSG:2190 | Datum S. Braz - S. Miguel (Grupo Oriental do Arquipélago dos Açores) / UTM zona 26N" %}
            {% trans "EPSG:2189 | Datum Base SW - Graciosa (Grupo Central do Arquipélago dos Açores) / UTM zona 26N" %}
            {% trans "EPSG:2188 | Datum Observatório - Flores (Grupo Ocidental do Arquipélago dos Açores) / UTM zona 25N" %}
            {% trans "EPSG:2188 | Datum Observatório - Flores (Grupo Ocidental do Arquipélago dos Açores) / UTM zona 25N" %}
            {% trans "Marégrafo de Cascais | 2.08m" %}
            {% trans "Zero Hidrográfico | 2.00m" %}
        -->
        <!-- temporary limitation-->
        {% if 'yes' in waves_type %}
            <div style='color: red'>
            {% blocktrans trimmed %}
                Na presente versão do OPENCoastS, em sistemas com ondas, apenas podem ser utilizadas malha com coordenadas cartesianas. Por favor carregue uma malha utilizando o sistema de coordenadas apropriado.
            {% endblocktrans %}
            </div>
        {% endif %}
      </div>
    </div>

    {% if errors %}
    <div class="alert alert-danger">
        <ul>
            {% for error in errors %}
            <li>{{ error }}</li>
            {% endfor %}
        </ul>
    </div>
    {% endif %}

    

    <form class="form" method="post" enctype="multipart/form-data">{% csrf_token %}
        <div class="forms" data-step="1" data-intro="{% trans 'Preencha o Formulário' %}">
            {% for field in forms.0 %}
            {% if 'crs' not in field.auto_id %}
            <div class="fieldWrapper">
                {{ field.label_tag }} {{ field }}
                {% if field.help_text %}
                <h5 class="text-info">{{ field.help_text|safe }}</h5>
                {% endif %}
                <h5 class="text-warning">{{ field.errors }}</h5>
            </div>
            {% else %}
            {% if 'crsv_list' in field.auto_id %}<div></div>{% endif %}
            <div class="fieldWrapper divinline">
                {{ field.label_tag }}<br/>{{ field }}
                <h5 class="text-warning">{{ field.errors }}</h5>
            </div>
            {% endif %}
            {% endfor %}
        </div>

        <div class="row btnmenu">
            <div class="col-xs-6">
                <button type="button" class="btn btn-default" onclick="window.location.href='{% url 'wizard:step1' %}'" data-step="3" data-intro="{% trans 'Pode sempre revisitar passos anteriores' %}">
                    <span class="glyphicon glyphicon-arrow-left"></span> {% trans "Anterior" %}
                </button>
            </div>
            <div class="col-xs-6 text-right">
                <button id="btn_submit" type="submit" name="edit" class="btn btn-primary" data-step="2" data-intro="{% trans 'Prima o botão' %}">
                    {% trans "Concluir passo" %} <span class="glyphicon glyphicon-arrow-right"></span>
                </button>
            </div>
        </div>
    </form>

    {% else %}

    <div class="panel panel-default">
      <div class="panel-heading">
          <strong>{% trans "Previsualização" %}</strong>
          <div class="help">
              <button id="help_btn" type="button" class="btn btn-primary btn-xs" data-toggle="tooltip" data-placement="top" title="{% trans 'Mais info' %}" data-title="{% trans 'Mais info' %}" data-title_alt="{% trans 'Menos info' %}">
                  <span class="glyphicon glyphicon-question-sign"></span>
              </button>
              <button id="tips_btn" type="button" class="btn btn-primary btn-xs" data-toggle="tooltip" data-placement="top" title="{% trans 'Dicas' %}">
                  <span class="glyphicon glyphicon-info-sign"></span>
              </button>
          </div>
      </div>
      <div id="help" class="alert alert-warning cst_hide">
          <p>{% blocktrans trimmed with brk="<br/>" %}
          Este passo intermédio permite uma pré-visualização da malha carregada pelo utilizador sobre um mapa bidimensional.
              Se a malha estiver válida, tanto no formato como no que se refere aos requisitos impostos pela própria plataforma,
              o utilizador poderá continuar o processo de montagem do sistema.{{ brk }}
          Nota: o Assistente de Configuração não permite o recarregamento de malhas para sistemas de previsão clonados a partir de outros.
        {% endblocktrans %}</p>
      </div>
      {% if grid_info %}
      <div class="panel-body">
      {% render_table grid_info %}
      </div>
      {% endif %}
    </div>

    {% if errors %}
    <div class="alert alert-danger">
        <ul>
            {% for error in errors %}
            <li>{{ error }}</li>
            {% endfor %}
        </ul>
    </div>
    {% endif %}

    <div id="mapcontainer">
        {% include "wizard/map.html" %}
    </div>

    <div class="row btnmenu">
        <div class="col-xs-8">
            <button id="btn_prev" type="button" class="btn btn-default" data-step="7" data-intro="{% trans 'Pode sempre revisitar passos anteriores' %}">
                <span class="glyphicon glyphicon-arrow-left"></span> {% trans "Anterior" %}
            </button>
            <button id="btn_restart" class="btn btn-default" {% if request.session.deploy_id %}{% if request.session.deploy_id.1 %}disabled{% endif %}{% endif %} data-step="6" data-intro="{% trans 'ou recarregue outra Malha' %}">{% trans "Recomeçar passo" %}</button>
        </div>
        <div class="col-xs-4 text-right">
          <button id="btn_next" class="btn btn-default{% if errors %} disabled" disabled="disabled"{% else %}"{% endif %} data-step="5" data-intro="{% trans 'Se não existirem erros prima o botão para continuar' %}">
            {% trans "Seguinte" %} <span class="glyphicon glyphicon-arrow-right"></span>
          </button>
        </div>
    </div>
    {% endif %}

    <script type="text/javascript">
        // Button Edit Step
        var crs_disabled = false;
        var crsv_disabled = false;

        // Submit Step event
        $('#btn_submit').click(function(e){
            e.preventDefault();

            var flagok = true;
            var msg = '{% trans "Para continuar terá de preencher os campos obrigatórios (*)." %}';
            // Validate form
            $('.form input, .form select').each(function(){
                if ($(this).prop('required') && $(this).val() == '') {
                    flagok = false;
                    return false;
                }
            });

            if (!flagok) {
                $('#msg_str').html(msg);
                $('#divModal_msg').modal('show');
                return false;
            } else {
                //$('#msg_str').html("In the present version of OPENCoastS with waves, only grids in Cartesian coordinates can be used.");
                //$('#divModal_msg').modal('show');
                $('#divModal_processing').modal('show');

                // Need to re-enable crs and crsv inputs if disabled or it's value won't be serialized in POST
                if (crs_disabled) $("#id_crs").removeAttr('disabled');
                if (crsv_disabled) $("#id_crsv").removeAttr('disabled');

                $.ajaxSetup({beforeSend: function(xhr, settings){
                    xhr.setRequestHeader('X-CSRFToken', '{{ csrf_token }}');
                }});

                $.ajax({
                    type: 'POST',
                    url: "{% url 'wizard:step2_validate_file' %}",
                    data: new FormData($('.form').get(0)),
                    contentType: false,
                    processData: false,
                    success: function(data) {
                        if (data['msg']) {
                            var msg = data['msg'];
                            if (msg != undefined) {
                                $('#divModal_processing').modal('hide');

                                $('#msg_str').html(msg);
                                $('#divModal_msg').modal('show');

                                var clear = data['clear'];
                                if (clear != undefined) $('.form')[0].reset();
                            } else {
                                window.location.href = "{% url 'wizard:step2' %}";
                            }
                        } else {
                            window.location.href = "{% url 'wizard:step2' %}";
                        }
                    },
                    error: function(e, x, r) {
                        $('#divModal_processing').modal('hide');

                        console.log(r + ' - ' + e);
                        $('#msg_str').html('{% trans "Ocorreu um erro ao carregar a malha." %}');
                        $('#divModal_msg').modal('show');
                        $('.form')[0].reset();

                        // if crs input was disabled before submit, must disable it again
                        if (crs_disabled) {
                            $("#id_crs").attr('disabled', '');
                            crs_disabled = false;
                        }

                        // if crsv input was disabled before submit, must disable it again
                        if (crsv_disabled) {
                            $("#id_crsv").attr('disabled', '');
                            crsv_disabled = false;
                        }
                    }
                });
            }
        });

        // On Document Ready
        $(function() {
            // Fill CRS input with selection from CRS list
            $("#id_crs_list").change(function(e) {
                e.preventDefault();

                var seloption = $(this).find("option:selected").text();
                var selvalue = null;
                if ($(this).val()) {
                    $("#id_crs").val($(this).val());
                    $("#id_crs").attr('disabled', '');
                    crs_disabled = true;
                } else {
                    $("#id_crs").removeAttr('disabled');
                    crs_disabled = false;
                }
            });

            // Fill CRSV input with selection from CRSV list
            $("#id_crsv_list").change(function(e) {
                e.preventDefault();

                var seloption = $(this).find("option:selected").text();
                var selvalue = null;
                if ($(this).val()) {
                    selvalue = seloption.split(' | ')[1].replace('m', '');
                    $("#id_crsv").val(selvalue);
                    $("#id_crsv").attr('disabled', '');
                    crsv_disabled = true;
                } else {
                    $("#id_crsv").removeAttr('disabled');
                    crsv_disabled = false;
                }
            });
            //temporary message, only apears when epsg input is empty
            {% if 'yes' in waves_type %}
            if ($("#id_crs").length > 0){ // check if user in on upload mesh page
                if ($("#id_crs").val().length === 0){ // while the crs is not selected, the msg keeps appearing on reload
                $('#msg_str').html("{% trans 'Na presente versão do OPENCoastS, em sistemas com ondas, apenas podem ser utilizadas malha com coordenadas cartesianas. Por favor carregue uma malha utilizando o sistema de coordenadas apropriado.' %}");
                $('#divModal_msg').modal('show');}
            }
            {% endif %}

        });
    </script>

{% endblock content %}